/* Copyright (c) 2009 Nordic Semiconductor. All Rights Reserved.
 *
 * The information contained herein is confidential property of Nordic
 * Semiconductor ASA.Terms and conditions of usage are described in detail
 * in NORDIC SEMICONDUCTOR STANDARD SOFTWARE LICENSE AGREEMENT.
 *
 * Licensees are granted free, non-transferable use of the information. NO
 * WARRANTY of ANY KIND is provided. This heading must NOT be removed from
 * the file.
 *
 */

#include <stdbool.h>
#include <stdint.h>
#include "nrf.h"
#include "nrf_gpio.h"
#include "nrf_delay.h"
#include "boards.h"

static uint32_t test __attribute__( ( section( "NoInit"), zero_init) );

int main(void)
{
    // Configure BUTTON0 as a regular input
    nrf_gpio_cfg_input(BUTTON0, NRF_GPIO_PIN_NOPULL);
    
    // Configure the LED pins as outputs
    nrf_gpio_range_cfg_output(LED_START, LED_STOP);
    
    // Dummy configure to trigger SYSTEMOFF wakeup.
    NRF_GPIO->PIN_CNF[BUTTON1] = (GPIO_PIN_CNF_SENSE_Low << GPIO_PIN_CNF_SENSE_Pos)
                               | (GPIO_PIN_CNF_DRIVE_S0S1 << GPIO_PIN_CNF_DRIVE_Pos)
                               | (GPIO_PIN_CNF_PULL_Pullup << GPIO_PIN_CNF_PULL_Pos)
                               | (GPIO_PIN_CNF_INPUT_Connect << GPIO_PIN_CNF_INPUT_Pos)
                               | (GPIO_PIN_CNF_DIR_Input << GPIO_PIN_CNF_DIR_Pos);
    nrf_delay_us(10*1000);
    nrf_gpio_cfg_output(18);
    // Blink LED to verify that variable "test" is not zero.
    if (test > 0)
    {
        nrf_gpio_pin_set(18);
        nrf_delay_us(100*1000);
        nrf_gpio_pin_clear(18);
        nrf_delay_us(100*1000);
    } 
    
    // If desired, change the RAM retention parameters:
    NRF_POWER->RAMON = POWER_RAMON_ONRAM0_RAM0On  << POWER_RAMON_ONRAM0_Pos
                     | POWER_RAMON_ONRAM1_RAM1On  << POWER_RAMON_ONRAM1_Pos
                     | POWER_RAMON_OFFRAM0_RAM0On  << POWER_RAMON_OFFRAM0_Pos
                     | POWER_RAMON_OFFRAM1_RAM1On  << POWER_RAMON_OFFRAM1_Pos;
    
    while(1)
    {     
        test++;
        NRF_POWER->SYSTEMOFF = 1;
    }
}
